import os
import sys
from pathlib import Path


class Size:
    def __init__(self):
        self.volume = 0
        self.count_files = 0
        self.count_dirs = 0

    @staticmethod
    def get_size(bts, ending='B'):
        for item in ["", "K", "M", "G", "T", "P"]:
            if bts < 1024:
                return f"{bts:.2f} {item}{ending}"
            bts /= 1024

    def counting(self, size):
        self.volume += size
        print(f'\r{self.get_size(self.volume)} total, {self.count_dirs} directories and {self.count_files} '
              f'files...', end='')

    def size_recurse(self, path):
        try:
            for file in os.scandir(path):
                if not file.is_dir(follow_symlinks=False):
                    self.count_files += 1
                    try:
                        self.counting(file.stat().st_size)
                    except:
                        continue
                else:
                    self.count_dirs += 1
                    self.counting(file.stat(follow_symlinks=False).st_size)
                    self.size_recurse(file.path)
            return self.volume
        except OSError:
            pass


if __name__ == "__main__":
    path_arg = []
    try:
        for i in range(1, 101):
            if sys.argv[i]:
                path_arg.append(sys.argv[i])
    except IndexError:
        path_arg = " ".join(path_arg)
        if path_arg:
            if Path(path_arg).exists() and Path(path_arg).is_dir():
                path_vol = Size().size_recurse(path_arg)
                print(f'\n{path_vol} bytes total')
            else:
                print("Директории не существует")
        else:
            print(f"Укажите путь к директории!\nПример:\n  volume.py {Path.cwd()}\n  volume.py G:\n  volume.py /home")
